Prime Path(BFS)

时间:2022-05-12 17:36:36

Prime Path

Time Limit : 2000/1000ms (Java/Other)   Memory Limit : 131072/65536K (Java/Other)
Total Submission(s) : 21   Accepted Submission(s) : 18
Problem Description
Prime Path(BFS)The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

1033
1733
3733
3739
3779
8779
8179

The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

 
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
 
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
 
Sample Input
3
1033 8179
1373 8017
1033 1033
 
Sample Output
6
7
 
Source
PKU
 
题意:
给出两个四位的素数,要求求出从其中一个变化到另一个数的最少的变化次数,每一次变化只变化四位中的一位,并且变化后的数也要是素数;
思路:
bfs,只不过是40入口的bfs,需要经过剪枝;每一次都枚举个位、十位、百位、千位的所有变化,检验室素数后加入到队列中;
AC代码:
Prime Path(BFS)Prime Path(BFS)
 #include<iostream>
#include<cstdio>
#include<cstring> using namespace std;
int a,b;
struct kf
{
int number;
int sgin;
}ks[];
bool ksgin[]={false}; bool shu(int sg)//判断sg是否是素数
{
if(sg==||sg==)
return true;
else if(sg<=||sg%==)
return false;
else if(sg>)
{
for(int i=;i*i<=sg;i+=)
if(sg%i==)
return false;
return true;
}
} int bfs()
{
int left,right;
kf s;
ks[left=right=].number=a;
ks[right++].sgin=;
ksgin[a]=false;
while(left<right){
s=ks[left++];
if(s.number==b){
cout<<s.sgin<<endl;
return ;
}
int ge=s.number%;
int shi=(s.number/)%;
for(int i=;i<=;i+=){//枚举个位
int y=s.number/*+i;
if(y!=s.number&&ksgin[y]&&shu(y)){
ksgin[y]=false;
ks[right].number=y;
ks[right++].sgin=s.sgin+;
}
}
for(int i=;i<=;i++){//枚举十位
int y=s.number/*+i*+ge;
if(y!=s.number&&ksgin[y]&&shu(y)){
ksgin[y]=false;
ks[right].number=y;
ks[right++].sgin=s.sgin+;
}
}
shi*=;
shi+=ge;
for(int i=;i<=;i++){//枚举百位
int y=s.number/*+i*+shi;
if(y!=s.number&&ksgin[y]&&shu(y)){
ksgin[y]=false;
ks[right].number=y;
ks[right++].sgin=s.sgin+;
}
}
shi=s.number%;
for(int i=;i<=;i++){//千位
int y=i*+shi;
if(y!=s.number&&ksgin[y]&&shu(y)){
ksgin[y]=false;
ks[right].number=y;
ks[right++].sgin=s.sgin+;
}
}
}
cout<<"Impossible"<<endl;
return ;
} int main()
{
// freopen("input.txt","r",stdin);
int test;
cin>>test;
while(test--){
memset(ksgin,true,sizeof(ksgin));
cin>>a>>b;
bfs();
}
}